#!/bin/bash

allParam="${@}"

# helpとversionが含まれている場合、ユーザーとパスワードは入力させない
skipUserPassword=0
for OPT in "$@"; do
    case $OPT in
        '-h'|'--help' )
            skipUserPassword=1
            ;;
        '-v'|'--version' )
            skipUserPassword=1
            ;;
    esac
    shift
done

setUserHere=0
if [ ${skipUserPassword} -eq 0 -a "${AGD_USER}" = "" ] ; then
    read -p "AGD login user name : " loginUser
    export AGD_USER="${loginUser}"
    setUserHere=1
fi
setPasswordHere=0
if [ ${skipUserPassword} -eq 0 -a "${AGD_PASSWORD}" = "" ] ; then
    read -sp "AGD Login Password  : " loginPassword
    echo ""
    export AGD_PASSWORD="${loginPassword}"
    setPasswordHere=1
fi

JAVA_PRIMARY_VERSION=`java -version 2>&1 | grep "java version" | awk -F\" '{print $2}' | awk -F\. '{print $1}' 2>&1`
VM_OPTS_ADD_OPENS=""
if [ ${JAVA_PRIMARY_VERSION} -eq 1 ]; then
    # jdk 8
    VM_OPTS_ADD_OPENS=""
elif [ ${JAVA_PRIMARY_VERSION} -ge 9 ]; then
    # jdk 9 or lator
    VM_OPTS_ADD_OPENS="--add-opens=java.base/java.lang=ALL-UNNAMED"
else
    echo "Invalid java version"
    exit 1
fi
java ${VM_OPTS_ADD_OPENS} -Xmx1024M -Djsse.enableSNIExtension=false -Djavax.xml.parsers.DocumentBuilderFactory=com.sun.org.apache.xerces.internal.jaxp.DocumentBuilderFactoryImpl -Djavax.xml.parsers.SAXParserFactory=com.sun.org.apache.xerces.internal.jaxp.SAXParserFactoryImpl -classpath agd.jar jp.ac.nig.ddbj.jga.egyptian.cli.CliDownloadMain ${allParam}
rc=${?}
if [ ${setUserHere} -eq 1 ]; then
    unset AGD_USER
fi
if [ ${setPasswordHere} -eq 1 ]; then
    unset AGD_PASSWORD
fi
exit ${rc}
